---
product: "AG Grid"
title: "Menu Item Component"
description: "Menu Item Components allow you to customise the menu items shown in the and . Use these when the provided menu items do not meet your requirements."
enterprise: true
framework: javascript
version: "36.2.0"
related:
    - title: "Tool Panels"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/tool-panel/"
    - title: "Quick Access Toolbar"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/toolbar/"
    - title: "Column Menu"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/column-menu/"
    - title: "Column Chooser"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/column-chooser/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/context-menu/"
    - title: "Status Bar"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/status-bar/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Menu Item Component

Menu Item Components allow you to customise the menu items shown in the [Column Menu](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/column-menu/) and [Context Menu](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/context-menu/). Use these when the provided menu items do not meet your requirements.

The following example demonstrates a custom menu item component in both the column menu and context menu. Clicking on the buttons in the custom menu items will log to the developer console.

#### Custom Menu Item Component

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GetContextMenuItemsParams,
  GetMainMenuItemsParams,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";
import { MenuItem } from "./menuItem";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ClipboardModule,
  ExcelExportModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

const columnDefs: ColDef[] = [
  { field: "athlete" },
  { field: "country" },
  { field: "sport" },
  { field: "year" },
  { field: "gold" },
  { field: "silver" },
  { field: "bronze" },
];

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  defaultColDef: {
    flex: 1,
    minWidth: 100,
  },
  columnDefs: columnDefs,
  rowData: null,
  getMainMenuItems: (params: GetMainMenuItemsParams) => {
    return [
      ...params.defaultItems,
      "separator",
      {
        name: "Click Alert Button and Close Menu",
        menuItem: MenuItem,
        menuItemParams: {
          buttonValue: "Alert",
        },
      },
      {
        name: "Click Alert Button and Keep Menu Open",
        suppressCloseOnSelect: true,
        menuItem: MenuItem,
        menuItemParams: {
          buttonValue: "Alert",
        },
      },
    ];
  },
  getContextMenuItems: (params: GetContextMenuItemsParams) => {
    return [
      ...(params.defaultItems || []),
      "separator",
      {
        name: "Click Alert Button and Close Menu",
        menuItem: MenuItem,
        menuItemParams: {
          buttonValue: "Alert",
        },
      },
      {
        name: "Click Alert Button and Keep Menu Open",
        suppressCloseOnSelect: true,
        menuItem: MenuItem,
        menuItemParams: {
          buttonValue: "Alert",
        },
      },
    ];
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) => {
    gridApi!.setGridOption("rowData", data);
  });
```

[Live example: Custom Menu Item Component](https://www.ag-grid.com/archive/36.2.0/examples/component-menu-item/custom-menu-item/typescript/)

Implement this interface to provide a custom menu item.

```ts
interface IMenuItemComp {
    // mandatory methods

    // Returns the DOM element for this menu item
    getGui(): HTMLElement;

    // optional methods

    // The init(params) method is called on the menu item once. See below for details on the parameters.
    init(params: IMenuItemParams): void;

    // Configure the default grid behaviour for this item, including styling,
    // and mouse and keyboard interactions.
    // Return `true` to use all default behaviour, `false` to use no default behaviour
    // (equivalent to `configureDefaults` not being defined),
    // or `IMenuConfigParams` to choose what default behaviour to use.
    configureDefaults(): boolean | IMenuConfigParams;

    // Called when the item is activated/deactivated, either via mouseover or keyboard navigation.
    setActive(active: boolean): void;

    // If the item has a sub menu, called when the sub menu is opened/closed.
    setExpanded(expanded: boolean): void;

    // Called when the item is selected, e.g. clicked or Enter is pressed.
    select(): void;
}
```

To enable the default menu item behaviour, implement the `configureDefaults` method and return `true` (see [Providing Custom Behaviour](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/component-menu-item/#providing-custom-behaviour)).

The interface for the menu item parameters is as follows:

Properties available on the `IMenuItemParams&lt;TData = any, TContext = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `onItemActivated` | `Function` |  |  |  |
| `level` | `number` |  |  |  |
| `isAnotherSubMenuOpen` | `Function` |  |  |  |
| `openSubMenu` | `Function` |  |  |  |
| `closeSubMenu` | `Function` |  |  |  |
| `closeMenu` | `Function` |  |  |  |
| `updateTooltip` | `Function` |  |  |  |
| `subMenu` | `(MenuItemDef \| string)[]` |  |  |  |
| `subMenuRole` | `'menu' \| 'listbox' \| 'tree' \| 'grid' \| 'dialog'` |  |  |  |
| `menuItem` | `any` |  |  |  |
| `menuItemParams` | `any` |  |  |  |
| `name` | `string` |  |  |  |
| `disabled` | `boolean` |  |  |  |
| `shortcut` | `string` |  |  |  |
| `action` | `Function` |  |  |  |
| `checked` | `boolean` |  |  |  |
| `icon` | `Element \| string` |  |  |  |
| `cssClasses` | `string[]` |  |  |  |
| `tooltip` | `string` |  |  |  |
| `suppressCloseOnSelect` | `boolean` |  |  |  |
| `api` | `GridApi` |  |  |  |
| `context` | `TContext` |  |  |  |

## Default Styling

In order for the menu to size dynamically, the default styling is provided via `display: table`. This means that if custom menu item components are used alongside grid-provided menu items, then they must adhere to a certain structure, or the grid styles must be overridden.

The default structure consists of a parent element with `display: table-row`, and four children with `display: table-cell`. This can be seen in the example above. If using `configureDefaults` and not suppressing root styling, the grid will automatically add the correct styling to the parent element.

This format can be overridden by [Styling the Menu](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-popups/), notably `ag-menu-list`, `ag-menu-option`, `ag-menu-option-part`, `ag-menu-separator` and `ag-menu-separator-part`. This is demonstrated in the [Providing Custom Behaviour](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/component-menu-item/#providing-custom-behaviour) example below.

## Providing Custom Behaviour

As described above, the easiest way to configure the behaviour of a custom menu item is returning `true` from `configureDefaults`.

If this is not done, then the custom menu item will need to implement all of the required behaviour itself.

It is also possible to disable certain parts of the behaviour by returning an object of type `IMenuConfigParams` from `configureDefaults`:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `suppressTooltip` | `boolean` |  |  |  |
| `suppressClick` | `boolean` |  |  |  |
| `suppressMouseDown` | `boolean` |  |  |  |
| `suppressMouseOver` | `boolean` |  |  |  |
| `suppressKeyboardSelect` | `boolean` |  |  |  |
| `suppressTabIndex` | `boolean` |  |  |  |
| `suppressAria` | `boolean` |  |  |  |
| `suppressRootStyles` | `boolean` |  |  |  |
| `suppressFocus` | `boolean` |  |  |  |

The following example demonstrates providing custom behaviour (in the column menu only) by including a filter as a menu item. To allow for a full-width custom menu item alongside grid-provided ones, the default menu styling is overridden (see [Default Styling](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/component-menu-item/#default-styling)).

#### Menu Item Component Without Defaults

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GetMainMenuItemsParams,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";
import { MenuItem } from "./menuItem";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ExcelExportModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

const columnDefs: ColDef[] = [
  { field: "athlete" },
  { field: "country" },
  { field: "sport" },
  { field: "year" },
  { field: "gold" },
  { field: "silver" },
  { field: "bronze" },
];

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  defaultColDef: {
    flex: 1,
    minWidth: 100,
    filter: true,
    suppressHeaderFilterButton: true,
  },
  columnDefs: columnDefs,
  getMainMenuItems: (params: GetMainMenuItemsParams) => {
    return [
      ...params.defaultItems.filter((item) => item !== "columnFilter"),
      "separator",
      {
        name: "Filter",
        menuItem: MenuItem,
        menuItemParams: {
          column: params.column,
        },
      },
    ];
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) => {
    gridApi!.setGridOption("rowData", data);
  });
```

[Live example: Menu Item Component Without Defaults](https://www.ag-grid.com/archive/36.2.0/examples/component-menu-item/menu-item-without-defaults/typescript/)

Note this shows a column filter in the custom menu item as an example for how complex items can be added. It is not meant to be used as a complete solution.


---
product: "AG Grid"
title: "Menu Item Component"
description: "Menu Item Components allow you to customise the menu items shown in the and . Use these when the provided menu items do not meet your requirements."
enterprise: true
framework: react
version: "36.2.0"
related:
    - title: "Tool Panels"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/tool-panel/"
    - title: "Quick Access Toolbar"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/toolbar/"
    - title: "Column Menu"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-menu/"
    - title: "Column Chooser"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-chooser/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/context-menu/"
    - title: "Status Bar"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/status-bar/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Menu Item Component

Menu Item Components allow you to customise the menu items shown in the [Column Menu](https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-menu/) and [Context Menu](https://www.ag-grid.com/archive/36.2.0/react-data-grid/context-menu/). Use these when the provided menu items do not meet your requirements.

The following example demonstrates a custom menu item component in both the column menu and context menu. Clicking on the buttons in the custom menu items will log to the developer console.

#### Custom Menu Item Component

```tsx
'use client';
import { useFetchJson } from './useFetchJson';
import React, { StrictMode, useCallback, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";

import type {
  ColDef,
  GetContextMenuItemsParams,
  GetMainMenuItemsParams,
} from "ag-grid-community";
import {
  ClientSideRowModelModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

import type { IOlympicData } from "./interfaces";
import MenuItem from "./menuItem";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ColumnMenuModule,

  ContextMenuModule,
  ExcelExportModule,
  CellSelectionModule,
  ClipboardModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete" },
    { field: "country" },
    { field: "sport" },
    { field: "year" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 100,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  const getMainMenuItems = useCallback((params: GetMainMenuItemsParams) => {
    return [
      ...params.defaultItems,
      "separator",
      {
        name: "Click Alert Button and Close Menu",
        menuItem: MenuItem,
        menuItemParams: {
          buttonValue: "Alert",
        },
      },
      {
        name: "Click Alert Button and Keep Menu Open",
        suppressCloseOnSelect: true,
        menuItem: MenuItem,
        menuItemParams: {
          buttonValue: "Alert",
        },
      },
    ];
  }, []);

  const getContextMenuItems = useCallback(
    (params: GetContextMenuItemsParams) => {
      return [
        ...(params.defaultItems || []),
        "separator",
        {
          name: "Click Alert Button and Close Menu",
          menuItem: MenuItem,
          menuItemParams: {
            buttonValue: "Alert",
          },
        },
        {
          name: "Click Alert Button and Keep Menu Open",
          suppressCloseOnSelect: true,
          menuItem: MenuItem,
          menuItemParams: {
            buttonValue: "Alert",
          },
        },
      ];
    },
    [],
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            getMainMenuItems={getMainMenuItems}
            getContextMenuItems={getContextMenuItems}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Custom Menu Item Component](https://www.ag-grid.com/archive/36.2.0/examples/component-menu-item/custom-menu-item/reactFunctionalTs/)

```jsx
export default ({ name, icon, shortcut, subMenu }) => {
    useGridMenuItem(() => {
        configureDefaults: () => true;
    });
    return (
        <div>
            <span className="ag-menu-option-part ag-menu-option-icon">{icon}</span>
            <span className="ag-menu-option-part ag-menu-option-text">{name}</span>
            <span className="ag-menu-option-part ag-menu-option-shortcut">{shortcut}</span>
            <span className="ag-menu-option-part ag-menu-option-popup-pointer">{subMenu ? '>': ''}</span>
        </div>
    );
};
```

> **Note**
>
> In previous versions of the grid, custom components were declared in an imperative way. See [Migrating to Use reactiveCustomComponents](https://www.ag-grid.com/archive/36.2.0/react-data-grid/upgrading-to-ag-grid-31-1/#migrating-custom-components-to-use-reactivecustomcomponents-option) for details on how to migrate to the current format.

To enable the default menu item behaviour, pass the callback `configureDefaults` to the `useGridMenuItem` hook and return `true` (see [Providing Custom Behaviour](https://www.ag-grid.com/archive/36.2.0/react-data-grid/component-menu-item/#providing-custom-behaviour)).

## Custom Menu Item Parameters

### Menu Item Props

The following props are passed to the custom menu item components (`CustomMenuItemProps` interface).

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `active` | `boolean` |  |  |  |
| `expanded` | `boolean` |  |  |  |
| `onActiveChange` | `Function` |  |  |  |
| `level` | `number` |  |  |  |
| `isAnotherSubMenuOpen` | `Function` |  |  |  |
| `openSubMenu` | `Function` |  |  |  |
| `closeSubMenu` | `Function` |  |  |  |
| `closeMenu` | `Function` |  |  |  |
| `updateTooltip` | `Function` |  |  |  |
| `subMenu` | `(MenuItemDef \| string)[]` |  |  |  |
| `subMenuRole` | `'menu' \| 'listbox' \| 'tree' \| 'grid' \| 'dialog'` |  |  |  |
| `menuItem` | `any` |  |  |  |
| `menuItemParams` | `any` |  |  |  |
| `name` | `string` |  |  |  |
| `disabled` | `boolean` |  |  |  |
| `shortcut` | `string` |  |  |  |
| `action` | `Function` |  |  |  |
| `checked` | `boolean` |  |  |  |
| `icon` | `Element \| string` |  |  |  |
| `cssClasses` | `string[]` |  |  |  |
| `tooltip` | `string` |  |  |  |
| `suppressCloseOnSelect` | `boolean` |  |  |  |
| `api` | `GridApi` |  |  |  |
| `context` | `TContext` |  |  |  |

### Menu Item Callbacks

The following callbacks can be passed to the `useGridMenuItem` hook (`CustomMenuItemCallbacks` interface). All the callbacks are optional, and the hook only needs to be used if callbacks are provided.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `select` | `Function` |  |  |  |
| `configureDefaults` | `Function` |  |  |  |

## Default Styling

In order for the menu to size dynamically, the default styling is provided via `display: table`. This means that if custom menu item components are used alongside grid-provided menu items, then they must adhere to a certain structure, or the grid styles must be overridden.

The default structure consists of a parent element with `display: table-row`, and four children with `display: table-cell`. This can be seen in the example above. If using `configureDefaults` and not suppressing root styling, the grid will automatically add the correct styling to the parent element.

This format can be overridden by [Styling the Menu](https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-popups/), notably `ag-menu-list`, `ag-menu-option`, `ag-menu-option-part`, `ag-menu-separator` and `ag-menu-separator-part`. This is demonstrated in the [Providing Custom Behaviour](https://www.ag-grid.com/archive/36.2.0/react-data-grid/component-menu-item/#providing-custom-behaviour) example below.

## Providing Custom Behaviour

As described above, the easiest way to configure the behaviour of a custom menu item is returning `true` from `configureDefaults`.

If this is not done, then the custom menu item will need to implement all of the required behaviour itself.

It is also possible to disable certain parts of the behaviour by returning an object of type `IMenuConfigParams` from `configureDefaults`:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `suppressTooltip` | `boolean` |  |  |  |
| `suppressClick` | `boolean` |  |  |  |
| `suppressMouseDown` | `boolean` |  |  |  |
| `suppressMouseOver` | `boolean` |  |  |  |
| `suppressKeyboardSelect` | `boolean` |  |  |  |
| `suppressTabIndex` | `boolean` |  |  |  |
| `suppressAria` | `boolean` |  |  |  |
| `suppressRootStyles` | `boolean` |  |  |  |
| `suppressFocus` | `boolean` |  |  |  |

The following example demonstrates providing custom behaviour (in the column menu only) by including a filter as a menu item. To allow for a full-width custom menu item alongside grid-provided ones, the default menu styling is overridden (see [Default Styling](https://www.ag-grid.com/archive/36.2.0/react-data-grid/component-menu-item/#default-styling)).

#### Menu Item Component Without Defaults

```tsx
'use client';
import { useFetchJson } from './useFetchJson';
import React, { StrictMode, useCallback, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";

import type { ColDef, GetMainMenuItems } from "ag-grid-community";
import {
  ClientSideRowModelModule,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

import type { IOlympicData } from "./interfaces";
import MenuItem from "./menuItem";
import "./style.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
  CellSelectionModule,
  ClipboardModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete" },
    { field: "country" },
    { field: "sport" },
    { field: "year" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 100,
      filter: true,
      suppressHeaderFilterButton: true,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  const getMainMenuItems = useCallback<GetMainMenuItems>((params) => {
    return [
      ...params.defaultItems.filter((item) => item !== "columnFilter"),
      "separator",
      {
        name: "Filter",
        menuItem: MenuItem,
        menuItemParams: {
          column: params.column,
        },
      },
    ];
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            getMainMenuItems={getMainMenuItems}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Menu Item Component Without Defaults](https://www.ag-grid.com/archive/36.2.0/examples/component-menu-item/menu-item-without-defaults/reactFunctionalTs/)

Note this shows a column filter in the custom menu item as an example for how complex items can be added. It is not meant to be used as a complete solution.


---
product: "AG Grid"
title: "Menu Item Component"
description: "Menu Item Components allow you to customise the menu items shown in the and . Use these when the provided menu items do not meet your requirements."
enterprise: true
framework: vue
version: "36.2.0"
related:
    - title: "Tool Panels"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/tool-panel/"
    - title: "Quick Access Toolbar"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/toolbar/"
    - title: "Column Menu"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-menu/"
    - title: "Column Chooser"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-chooser/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/context-menu/"
    - title: "Status Bar"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/status-bar/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Menu Item Component

Menu Item Components allow you to customise the menu items shown in the [Column Menu](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-menu/) and [Context Menu](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/context-menu/). Use these when the provided menu items do not meet your requirements.

The following example demonstrates a custom menu item component in both the column menu and context menu. Clicking on the buttons in the custom menu items will log to the developer console.

#### Custom Menu Item Component

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";

import type {
  ColDef,
  GetContextMenuItemsParams,
  GetMainMenuItemsParams,
  GridApi,
  GridReadyEvent,
} from "ag-grid-community";
import {
  ClientSideRowModelModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";
import { AgGridVue } from "ag-grid-vue3";

import MenuItem from "./menuItemVue";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
  CellSelectionModule,
  ClipboardModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
            <ag-grid-vue
                style="width: 100%; height: 100%;"
                :columnDefs="columnDefs"
                @grid-ready="onGridReady"
                :defaultColDef="defaultColDef"
                :rowData="rowData"
                :getMainMenuItems="getMainMenuItems"
                :getContextMenuItems="getContextMenuItems"
            >
            </ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
    MenuItem,
  },
  setup(props) {
    const columnDefs = ref<ColDef[]>([
      { field: "athlete" },
      { field: "country" },
      { field: "sport" },
      { field: "year" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
    ]);
    const gridApi = shallowRef<GridApi | null>(null);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 100,
    });
    const getMainMenuItems = ref(null);
    const getContextMenuItems = ref(null);
    const rowData = ref<any[]>(null);

    onBeforeMount(() => {
      getMainMenuItems.value = (params: GetMainMenuItemsParams) => {
        return [
          ...params.defaultItems,
          "separator",
          {
            name: "Click Alert Button and Close Menu",
            menuItem: "MenuItem",
            menuItemParams: {
              buttonValue: "Alert",
            },
          },
          {
            name: "Click Alert Button and Keep Menu Open",
            suppressCloseOnSelect: true,
            menuItem: "MenuItem",
            menuItemParams: {
              buttonValue: "Alert",
            },
          },
        ];
      };
      getContextMenuItems.value = (params: GetContextMenuItemsParams) => {
        return [
          ...(params.defaultItems || []),
          "separator",
          {
            name: "Click Alert Button and Close Menu",
            menuItem: "MenuItem",
            menuItemParams: {
              buttonValue: "Alert",
            },
          },
          {
            name: "Click Alert Button and Keep Menu Open",
            suppressCloseOnSelect: true,
            menuItem: "MenuItem",
            menuItemParams: {
              buttonValue: "Alert",
            },
          },
        ];
      };
    });

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => {
        rowData.value = data;
      };

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      columnDefs,
      gridApi,
      defaultColDef,
      rowData,
      getMainMenuItems,
      getContextMenuItems,
      onGridReady,
    };
  },
});

createApp(VueExample).mount("#app");
```

[Live example: Custom Menu Item Component](https://www.ag-grid.com/archive/36.2.0/examples/component-menu-item/custom-menu-item/vue3/)

Implement this interface to provide a custom menu item.

```ts
interface IMenuItem {
    // optional methods

    // Configure the default grid behaviour for this item, including styling,
    // and mouse and keyboard interactions.
    // Return `true` to use all default behaviour, `false` to use no default behaviour
    // (equivalent to `configureDefaults` not being defined),
    // or `IMenuConfigParams` to choose what default behaviour to use.
    configureDefaults(): boolean | IMenuConfigParams;

    // Called when the item is activated/deactivated, either via mouseover or keyboard navigation.
    setActive(active: boolean): void;

    // If the item has a sub menu, called when the sub menu is opened/closed.
    setExpanded(expanded: boolean): void;

    // Called when the item is selected, e.g. clicked or Enter is pressed.
    select(): void;
}
```

To enable the default menu item behaviour, implement the `configureDefaults` method and return `true` (see [Providing Custom Behaviour](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/component-menu-item/#providing-custom-behaviour)).

When a menu item is instantiated, the following will be made available on `this.params`:

Properties available on the `IMenuItemParams&lt;TData = any, TContext = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `onItemActivated` | `Function` |  |  |  |
| `level` | `number` |  |  |  |
| `isAnotherSubMenuOpen` | `Function` |  |  |  |
| `openSubMenu` | `Function` |  |  |  |
| `closeSubMenu` | `Function` |  |  |  |
| `closeMenu` | `Function` |  |  |  |
| `updateTooltip` | `Function` |  |  |  |
| `subMenu` | `(MenuItemDef \| string)[]` |  |  |  |
| `subMenuRole` | `'menu' \| 'listbox' \| 'tree' \| 'grid' \| 'dialog'` |  |  |  |
| `menuItem` | `any` |  |  |  |
| `menuItemParams` | `any` |  |  |  |
| `name` | `string` |  |  |  |
| `disabled` | `boolean` |  |  |  |
| `shortcut` | `string` |  |  |  |
| `action` | `Function` |  |  |  |
| `checked` | `boolean` |  |  |  |
| `icon` | `Element \| string` |  |  |  |
| `cssClasses` | `string[]` |  |  |  |
| `tooltip` | `string` |  |  |  |
| `suppressCloseOnSelect` | `boolean` |  |  |  |
| `api` | `GridApi` |  |  |  |
| `context` | `TContext` |  |  |  |

## Default Styling

In order for the menu to size dynamically, the default styling is provided via `display: table`. This means that if custom menu item components are used alongside grid-provided menu items, then they must adhere to a certain structure, or the grid styles must be overridden.

The default structure consists of a parent element with `display: table-row`, and four children with `display: table-cell`. This can be seen in the example above. If using `configureDefaults` and not suppressing root styling, the grid will automatically add the correct styling to the parent element.

This format can be overridden by [Styling the Menu](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-popups/), notably `ag-menu-list`, `ag-menu-option`, `ag-menu-option-part`, `ag-menu-separator` and `ag-menu-separator-part`. This is demonstrated in the [Providing Custom Behaviour](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/component-menu-item/#providing-custom-behaviour) example below.

## Providing Custom Behaviour

As described above, the easiest way to configure the behaviour of a custom menu item is returning `true` from `configureDefaults`.

If this is not done, then the custom menu item will need to implement all of the required behaviour itself.

It is also possible to disable certain parts of the behaviour by returning an object of type `IMenuConfigParams` from `configureDefaults`:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `suppressTooltip` | `boolean` |  |  |  |
| `suppressClick` | `boolean` |  |  |  |
| `suppressMouseDown` | `boolean` |  |  |  |
| `suppressMouseOver` | `boolean` |  |  |  |
| `suppressKeyboardSelect` | `boolean` |  |  |  |
| `suppressTabIndex` | `boolean` |  |  |  |
| `suppressAria` | `boolean` |  |  |  |
| `suppressRootStyles` | `boolean` |  |  |  |
| `suppressFocus` | `boolean` |  |  |  |

The following example demonstrates providing custom behaviour (in the column menu only) by including a filter as a menu item. To allow for a full-width custom menu item alongside grid-provided ones, the default menu styling is overridden (see [Default Styling](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/component-menu-item/#default-styling)).

#### Menu Item Component Without Defaults

```ts
import { createApp, onBeforeMount, ref, shallowRef } from "vue";

import {
  ClientSideRowModelModule,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";
import { AgGridVue } from "ag-grid-vue3";

import MenuItem from "./menuItemVue";
import "./style.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  TextFilterModule,
  NumberFilterModule,
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
  CellSelectionModule,
  ClipboardModule,
]);

const VueExample = {
  template: `
        <div style="height: 100%">
            <ag-grid-vue
                style="width: 100%; height: 100%;"
                :columnDefs="columnDefs"
                @grid-ready="onGridReady"
                :defaultColDef="defaultColDef"
                :rowData="rowData"
                :getMainMenuItems="getMainMenuItems">
            </ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
    MenuItem,
  },
  setup(props) {
    const columnDefs = ref([
      { field: "athlete" },
      { field: "country" },
      { field: "sport" },
      { field: "year" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
    ]);
    const gridApi = shallowRef();
    const defaultColDef = ref({
      flex: 1,
      minWidth: 100,
      filter: true,
      suppressHeaderFilterButton: true,
    });
    const getMainMenuItems = ref(null);
    const rowData = ref(null);

    onBeforeMount(() => {
      getMainMenuItems.value = (params) => {
        return [
          ...params.defaultItems.filter((item) => item !== "columnFilter"),
          "separator",
          {
            name: "Filter",
            menuItem: "MenuItem",
            menuItemParams: {
              column: params.column,
            },
          },
        ];
      };
    });

    const onGridReady = (params) => {
      gridApi.value = params.api;

      const updateData = (data) => {
        rowData.value = data;
      };

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      columnDefs,
      gridApi,
      defaultColDef,
      rowData,
      getMainMenuItems,
      onGridReady,
    };
  },
};

createApp(VueExample).mount("#app");
```

[Live example: Menu Item Component Without Defaults](https://www.ag-grid.com/archive/36.2.0/examples/component-menu-item/menu-item-without-defaults/vue3/)

Note this shows a column filter in the custom menu item as an example for how complex items can be added. It is not meant to be used as a complete solution.


---
product: "AG Grid"
title: "Menu Item Component"
description: "Menu Item Components allow you to customise the menu items shown in the and . Use these when the provided menu items do not meet your requirements."
enterprise: true
framework: angular
version: "36.2.0"
related:
    - title: "Tool Panels"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/tool-panel/"
    - title: "Quick Access Toolbar"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/toolbar/"
    - title: "Column Menu"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-menu/"
    - title: "Column Chooser"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-chooser/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/context-menu/"
    - title: "Status Bar"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/status-bar/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Menu Item Component

Menu Item Components allow you to customise the menu items shown in the [Column Menu](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-menu/) and [Context Menu](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/context-menu/). Use these when the provided menu items do not meet your requirements.

The following example demonstrates a custom menu item component in both the column menu and context menu. Clicking on the buttons in the custom menu items will log to the developer console.

#### Custom Menu Item Component

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetContextMenuItems,
  GetContextMenuItemsParams,
  GetMainMenuItems,
  GetMainMenuItemsParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ClipboardModule,
  ExcelExportModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);
import { MenuItem } from "./menu-item.component";
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular, MenuItem],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    [getMainMenuItems]="getMainMenuItems"
    [getContextMenuItems]="getContextMenuItems"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete" },
    { field: "country" },
    { field: "sport" },
    { field: "year" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 100,
  };
  getMainMenuItems: GetMainMenuItems = (params: GetMainMenuItemsParams) => {
    return [
      ...params.defaultItems,
      "separator",
      {
        name: "Click Alert Button and Close Menu",
        menuItem: MenuItem,
        menuItemParams: {
          buttonValue: "Alert",
        },
      },
      {
        name: "Click Alert Button and Keep Menu Open",
        suppressCloseOnSelect: true,
        menuItem: MenuItem,
        menuItemParams: {
          buttonValue: "Alert",
        },
      },
    ];
  };
  getContextMenuItems: GetContextMenuItems = (
    params: GetContextMenuItemsParams,
  ) => {
    return [
      ...(params.defaultItems || []),
      "separator",
      {
        name: "Click Alert Button and Close Menu",
        menuItem: MenuItem,
        menuItemParams: {
          buttonValue: "Alert",
        },
      },
      {
        name: "Click Alert Button and Keep Menu Open",
        suppressCloseOnSelect: true,
        menuItem: MenuItem,
        menuItemParams: {
          buttonValue: "Alert",
        },
      },
    ];
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => {
        this.rowData = data;
      });
  }
}
```

[Live example: Custom Menu Item Component](https://www.ag-grid.com/archive/36.2.0/examples/component-menu-item/custom-menu-item/angular/)

Implement this interface to provide a custom menu item.

```ts
interface extends IMenuItemAngularComp {
    // mandatory methods

    // The agInit(params) method is called on the menu item once.
    agInit(params: IMenuItemParams);

    // optional methods

    // Configure the default grid behaviour for this item, including styling,
    // and mouse and keyboard interactions.
    // Return `true` to use all default behaviour, `false` to use no default behaviour
    // (equivalent to `configureDefaults` not being defined),
    // or `IMenuConfigParams` to choose what default behaviour to use.
    configureDefaults(): boolean | IMenuConfigParams;

    // Called when the item is activated/deactivated, either via mouseover or keyboard navigation.
    setActive(active: boolean): void;

    // If the item has a sub menu, called when the sub menu is opened/closed.
    setExpanded(expanded: boolean): void;

    // Called when the item is selected, e.g. clicked or Enter is pressed.
    select(): void;
}
```

To enable the default menu item behaviour, implement the `configureDefaults` method and return `true` (see [Providing Custom Behaviour](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/component-menu-item/#providing-custom-behaviour)).

The `agInit(params)` method takes a params object with the items listed below:

Properties available on the `IMenuItemParams&lt;TData = any, TContext = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `onItemActivated` | `Function` |  |  |  |
| `level` | `number` |  |  |  |
| `isAnotherSubMenuOpen` | `Function` |  |  |  |
| `openSubMenu` | `Function` |  |  |  |
| `closeSubMenu` | `Function` |  |  |  |
| `closeMenu` | `Function` |  |  |  |
| `updateTooltip` | `Function` |  |  |  |
| `subMenu` | `(MenuItemDef \| string)[]` |  |  |  |
| `subMenuRole` | `'menu' \| 'listbox' \| 'tree' \| 'grid' \| 'dialog'` |  |  |  |
| `menuItem` | `any` |  |  |  |
| `menuItemParams` | `any` |  |  |  |
| `name` | `string` |  |  |  |
| `disabled` | `boolean` |  |  |  |
| `shortcut` | `string` |  |  |  |
| `action` | `Function` |  |  |  |
| `checked` | `boolean` |  |  |  |
| `icon` | `Element \| string` |  |  |  |
| `cssClasses` | `string[]` |  |  |  |
| `tooltip` | `string` |  |  |  |
| `suppressCloseOnSelect` | `boolean` |  |  |  |
| `api` | `GridApi` |  |  |  |
| `context` | `TContext` |  |  |  |

## Default Styling

In order for the menu to size dynamically, the default styling is provided via `display: table`. This means that if custom menu item components are used alongside grid-provided menu items, then they must adhere to a certain structure, or the grid styles must be overridden.

The default structure consists of a parent element with `display: table-row`, and four children with `display: table-cell`. This can be seen in the example above. If using `configureDefaults` and not suppressing root styling, the grid will automatically add the correct styling to the parent element.

This format can be overridden by [Styling the Menu](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-popups/), notably `ag-menu-list`, `ag-menu-option`, `ag-menu-option-part`, `ag-menu-separator` and `ag-menu-separator-part`. This is demonstrated in the [Providing Custom Behaviour](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/component-menu-item/#providing-custom-behaviour) example below.

## Providing Custom Behaviour

As described above, the easiest way to configure the behaviour of a custom menu item is returning `true` from `configureDefaults`.

If this is not done, then the custom menu item will need to implement all of the required behaviour itself.

It is also possible to disable certain parts of the behaviour by returning an object of type `IMenuConfigParams` from `configureDefaults`:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `suppressTooltip` | `boolean` |  |  |  |
| `suppressClick` | `boolean` |  |  |  |
| `suppressMouseDown` | `boolean` |  |  |  |
| `suppressMouseOver` | `boolean` |  |  |  |
| `suppressKeyboardSelect` | `boolean` |  |  |  |
| `suppressTabIndex` | `boolean` |  |  |  |
| `suppressAria` | `boolean` |  |  |  |
| `suppressRootStyles` | `boolean` |  |  |  |
| `suppressFocus` | `boolean` |  |  |  |

The following example demonstrates providing custom behaviour (in the column menu only) by including a filter as a menu item. To allow for a full-width custom menu item alongside grid-provided ones, the default menu styling is overridden (see [Default Styling](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/component-menu-item/#default-styling)).

#### Menu Item Component Without Defaults

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetMainMenuItems,
  GetMainMenuItemsParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  ExcelExportModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ExcelExportModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);
import { MenuItem } from "./menu-item.component";
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular, MenuItem],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [getMainMenuItems]="getMainMenuItems"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete" },
    { field: "country" },
    { field: "sport" },
    { field: "year" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 100,
    filter: true,
    suppressHeaderFilterButton: true,
  };
  getMainMenuItems: GetMainMenuItems = (params: GetMainMenuItemsParams) => {
    return [
      ...params.defaultItems.filter((item) => item !== "columnFilter"),
      "separator",
      {
        name: "Filter",
        menuItem: MenuItem,
        menuItemParams: {
          column: params.column,
        },
      },
    ];
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => {
        this.rowData = data;
      });
  }
}
```

[Live example: Menu Item Component Without Defaults](https://www.ag-grid.com/archive/36.2.0/examples/component-menu-item/menu-item-without-defaults/angular/)

Note this shows a column filter in the custom menu item as an example for how complex items can be added. It is not meant to be used as a complete solution.
